package org.apache.commons.lang3.text;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.nio.CharBuffer;
import java.util.Iterator;
import java.util.Objects;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.builder.Builder;
import org.apache.commons.lang3.text.StrMatcher;
import org.apache.commons.lang3.text.StrTokenizer;

@Deprecated
public class StrBuilder implements CharSequence, Appendable, Serializable, Builder<String> {
  static final int CAPACITY = 32;
  
  private static final long serialVersionUID = 7628716375283629643L;
  
  protected char[] buffer;
  
  protected int size;
  
  private String newLine;
  
  private String nullText;
  
  public StrBuilder() {
    this(32);
  }
  
  public StrBuilder(int initialCapacity) {
    if (initialCapacity <= 0)
      initialCapacity = 32; 
    this.buffer = new char[initialCapacity];
  }
  
  public StrBuilder(String str) {
    if (str == null) {
      this.buffer = new char[32];
    } else {
      this.buffer = new char[str.length() + 32];
      append(str);
    } 
  }
  
  public String getNewLineText() {
    return this.newLine;
  }
  
  public org.apache.commons.lang3.text.StrBuilder setNewLineText(String newLine) {
    this.newLine = newLine;
    return this;
  }
  
  public String getNullText() {
    return this.nullText;
  }
  
  public org.apache.commons.lang3.text.StrBuilder setNullText(String nullText) {
    if (nullText != null && nullText.isEmpty())
      nullText = null; 
    this.nullText = nullText;
    return this;
  }
  
  public int length() {
    return this.size;
  }
  
  public org.apache.commons.lang3.text.StrBuilder setLength(int length) {
    if (length < 0)
      throw new StringIndexOutOfBoundsException(length); 
    if (length < this.size) {
      this.size = length;
    } else if (length > this.size) {
      ensureCapacity(length);
      int oldEnd = this.size;
      int newEnd = length;
      this.size = length;
      for (int i = oldEnd; i < newEnd; i++)
        this.buffer[i] = Character.MIN_VALUE; 
    } 
    return this;
  }
  
  public int capacity() {
    return this.buffer.length;
  }
  
  public org.apache.commons.lang3.text.StrBuilder ensureCapacity(int capacity) {
    if (capacity > this.buffer.length) {
      char[] old = this.buffer;
      this.buffer = new char[capacity * 2];
      System.arraycopy(old, 0, this.buffer, 0, this.size);
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder minimizeCapacity() {
    if (this.buffer.length > length()) {
      char[] old = this.buffer;
      this.buffer = new char[length()];
      System.arraycopy(old, 0, this.buffer, 0, this.size);
    } 
    return this;
  }
  
  public int size() {
    return this.size;
  }
  
  public boolean isEmpty() {
    return (this.size == 0);
  }
  
  public boolean isNotEmpty() {
    return (this.size > 0);
  }
  
  public org.apache.commons.lang3.text.StrBuilder clear() {
    this.size = 0;
    return this;
  }
  
  public char charAt(int index) {
    if (index < 0 || index >= length())
      throw new StringIndexOutOfBoundsException(index); 
    return this.buffer[index];
  }
  
  public org.apache.commons.lang3.text.StrBuilder setCharAt(int index, char ch) {
    if (index < 0 || index >= length())
      throw new StringIndexOutOfBoundsException(index); 
    this.buffer[index] = ch;
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder deleteCharAt(int index) {
    if (index < 0 || index >= this.size)
      throw new StringIndexOutOfBoundsException(index); 
    deleteImpl(index, index + 1, 1);
    return this;
  }
  
  public char[] toCharArray() {
    if (this.size == 0)
      return ArrayUtils.EMPTY_CHAR_ARRAY; 
    char[] chars = new char[this.size];
    System.arraycopy(this.buffer, 0, chars, 0, this.size);
    return chars;
  }
  
  public char[] toCharArray(int startIndex, int endIndex) {
    endIndex = validateRange(startIndex, endIndex);
    int len = endIndex - startIndex;
    if (len == 0)
      return ArrayUtils.EMPTY_CHAR_ARRAY; 
    char[] chars = new char[len];
    System.arraycopy(this.buffer, startIndex, chars, 0, len);
    return chars;
  }
  
  public char[] getChars(char[] destination) {
    int len = length();
    if (destination == null || destination.length < len)
      destination = new char[len]; 
    System.arraycopy(this.buffer, 0, destination, 0, len);
    return destination;
  }
  
  public void getChars(int startIndex, int endIndex, char[] destination, int destinationIndex) {
    if (startIndex < 0)
      throw new StringIndexOutOfBoundsException(startIndex); 
    if (endIndex < 0 || endIndex > length())
      throw new StringIndexOutOfBoundsException(endIndex); 
    if (startIndex > endIndex)
      throw new StringIndexOutOfBoundsException("end < start"); 
    System.arraycopy(this.buffer, startIndex, destination, destinationIndex, endIndex - startIndex);
  }
  
  public int readFrom(Readable readable) throws IOException {
    int oldSize = this.size;
    if (readable instanceof Reader) {
      Reader r = (Reader)readable;
      ensureCapacity(this.size + 1);
      int read;
      while ((read = r.read(this.buffer, this.size, this.buffer.length - this.size)) != -1) {
        this.size += read;
        ensureCapacity(this.size + 1);
      } 
    } else if (readable instanceof CharBuffer) {
      CharBuffer cb = (CharBuffer)readable;
      int remaining = cb.remaining();
      ensureCapacity(this.size + remaining);
      cb.get(this.buffer, this.size, remaining);
      this.size += remaining;
    } else {
      while (true) {
        ensureCapacity(this.size + 1);
        CharBuffer buf = CharBuffer.wrap(this.buffer, this.size, this.buffer.length - this.size);
        int read = readable.read(buf);
        if (read == -1)
          break; 
        this.size += read;
      } 
    } 
    return this.size - oldSize;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendNewLine() {
    if (this.newLine == null) {
      append(System.lineSeparator());
      return this;
    } 
    return append(this.newLine);
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendNull() {
    if (this.nullText == null)
      return this; 
    return append(this.nullText);
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(Object obj) {
    if (obj == null)
      return appendNull(); 
    if (obj instanceof CharSequence)
      return append((CharSequence)obj); 
    return append(obj.toString());
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(CharSequence seq) {
    if (seq == null)
      return appendNull(); 
    if (seq instanceof org.apache.commons.lang3.text.StrBuilder)
      return append((org.apache.commons.lang3.text.StrBuilder)seq); 
    if (seq instanceof StringBuilder)
      return append((StringBuilder)seq); 
    if (seq instanceof StringBuffer)
      return append((StringBuffer)seq); 
    if (seq instanceof CharBuffer)
      return append((CharBuffer)seq); 
    return append(seq.toString());
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(CharSequence seq, int startIndex, int length) {
    if (seq == null)
      return appendNull(); 
    return append(seq.toString(), startIndex, length);
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(String str) {
    if (str == null)
      return appendNull(); 
    int strLen = str.length();
    if (strLen > 0) {
      int len = length();
      ensureCapacity(len + strLen);
      str.getChars(0, strLen, this.buffer, len);
      this.size += strLen;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(String str, int startIndex, int length) {
    if (str == null)
      return appendNull(); 
    if (startIndex < 0 || startIndex > str.length())
      throw new StringIndexOutOfBoundsException("startIndex must be valid"); 
    if (length < 0 || startIndex + length > str.length())
      throw new StringIndexOutOfBoundsException("length must be valid"); 
    if (length > 0) {
      int len = length();
      ensureCapacity(len + length);
      str.getChars(startIndex, startIndex + length, this.buffer, len);
      this.size += length;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(String format, Object... objs) {
    return append(String.format(format, objs));
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(CharBuffer buf) {
    if (buf == null)
      return appendNull(); 
    if (buf.hasArray()) {
      int length = buf.remaining();
      int len = length();
      ensureCapacity(len + length);
      System.arraycopy(buf.array(), buf.arrayOffset() + buf.position(), this.buffer, len, length);
      this.size += length;
    } else {
      append(buf.toString());
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(CharBuffer buf, int startIndex, int length) {
    if (buf == null)
      return appendNull(); 
    if (buf.hasArray()) {
      int totalLength = buf.remaining();
      if (startIndex < 0 || startIndex > totalLength)
        throw new StringIndexOutOfBoundsException("startIndex must be valid"); 
      if (length < 0 || startIndex + length > totalLength)
        throw new StringIndexOutOfBoundsException("length must be valid"); 
      int len = length();
      ensureCapacity(len + length);
      System.arraycopy(buf.array(), buf.arrayOffset() + buf.position() + startIndex, this.buffer, len, length);
      this.size += length;
    } else {
      append(buf.toString(), startIndex, length);
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(StringBuffer str) {
    if (str == null)
      return appendNull(); 
    int strLen = str.length();
    if (strLen > 0) {
      int len = length();
      ensureCapacity(len + strLen);
      str.getChars(0, strLen, this.buffer, len);
      this.size += strLen;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(StringBuffer str, int startIndex, int length) {
    if (str == null)
      return appendNull(); 
    if (startIndex < 0 || startIndex > str.length())
      throw new StringIndexOutOfBoundsException("startIndex must be valid"); 
    if (length < 0 || startIndex + length > str.length())
      throw new StringIndexOutOfBoundsException("length must be valid"); 
    if (length > 0) {
      int len = length();
      ensureCapacity(len + length);
      str.getChars(startIndex, startIndex + length, this.buffer, len);
      this.size += length;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(StringBuilder str) {
    if (str == null)
      return appendNull(); 
    int strLen = str.length();
    if (strLen > 0) {
      int len = length();
      ensureCapacity(len + strLen);
      str.getChars(0, strLen, this.buffer, len);
      this.size += strLen;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(StringBuilder str, int startIndex, int length) {
    if (str == null)
      return appendNull(); 
    if (startIndex < 0 || startIndex > str.length())
      throw new StringIndexOutOfBoundsException("startIndex must be valid"); 
    if (length < 0 || startIndex + length > str.length())
      throw new StringIndexOutOfBoundsException("length must be valid"); 
    if (length > 0) {
      int len = length();
      ensureCapacity(len + length);
      str.getChars(startIndex, startIndex + length, this.buffer, len);
      this.size += length;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(org.apache.commons.lang3.text.StrBuilder str) {
    if (str == null)
      return appendNull(); 
    int strLen = str.length();
    if (strLen > 0) {
      int len = length();
      ensureCapacity(len + strLen);
      System.arraycopy(str.buffer, 0, this.buffer, len, strLen);
      this.size += strLen;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(org.apache.commons.lang3.text.StrBuilder str, int startIndex, int length) {
    if (str == null)
      return appendNull(); 
    if (startIndex < 0 || startIndex > str.length())
      throw new StringIndexOutOfBoundsException("startIndex must be valid"); 
    if (length < 0 || startIndex + length > str.length())
      throw new StringIndexOutOfBoundsException("length must be valid"); 
    if (length > 0) {
      int len = length();
      ensureCapacity(len + length);
      str.getChars(startIndex, startIndex + length, this.buffer, len);
      this.size += length;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(char[] chars) {
    if (chars == null)
      return appendNull(); 
    int strLen = chars.length;
    if (strLen > 0) {
      int len = length();
      ensureCapacity(len + strLen);
      System.arraycopy(chars, 0, this.buffer, len, strLen);
      this.size += strLen;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(char[] chars, int startIndex, int length) {
    if (chars == null)
      return appendNull(); 
    if (startIndex < 0 || startIndex > chars.length)
      throw new StringIndexOutOfBoundsException("Invalid startIndex: " + length); 
    if (length < 0 || startIndex + length > chars.length)
      throw new StringIndexOutOfBoundsException("Invalid length: " + length); 
    if (length > 0) {
      int len = length();
      ensureCapacity(len + length);
      System.arraycopy(chars, startIndex, this.buffer, len, length);
      this.size += length;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(boolean value) {
    if (value) {
      ensureCapacity(this.size + 4);
      this.buffer[this.size++] = 't';
      this.buffer[this.size++] = 'r';
      this.buffer[this.size++] = 'u';
      this.buffer[this.size++] = 'e';
    } else {
      ensureCapacity(this.size + 5);
      this.buffer[this.size++] = 'f';
      this.buffer[this.size++] = 'a';
      this.buffer[this.size++] = 'l';
      this.buffer[this.size++] = 's';
      this.buffer[this.size++] = 'e';
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(char ch) {
    int len = length();
    ensureCapacity(len + 1);
    this.buffer[this.size++] = ch;
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(int value) {
    return append(String.valueOf(value));
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(long value) {
    return append(String.valueOf(value));
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(float value) {
    return append(String.valueOf(value));
  }
  
  public org.apache.commons.lang3.text.StrBuilder append(double value) {
    return append(String.valueOf(value));
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(Object obj) {
    return append(obj).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(String str) {
    return append(str).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(String str, int startIndex, int length) {
    return append(str, startIndex, length).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(String format, Object... objs) {
    return append(format, objs).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(StringBuffer str) {
    return append(str).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(StringBuilder str) {
    return append(str).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(StringBuilder str, int startIndex, int length) {
    return append(str, startIndex, length).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(StringBuffer str, int startIndex, int length) {
    return append(str, startIndex, length).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(org.apache.commons.lang3.text.StrBuilder str) {
    return append(str).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(org.apache.commons.lang3.text.StrBuilder str, int startIndex, int length) {
    return append(str, startIndex, length).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(char[] chars) {
    return append(chars).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(char[] chars, int startIndex, int length) {
    return append(chars, startIndex, length).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(boolean value) {
    return append(value).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(char ch) {
    return append(ch).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(int value) {
    return append(value).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(long value) {
    return append(value).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(float value) {
    return append(value).appendNewLine();
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendln(double value) {
    return append(value).appendNewLine();
  }
  
  public <T> org.apache.commons.lang3.text.StrBuilder appendAll(T... array) {
    if (ArrayUtils.isNotEmpty((Object[])array))
      for (T element : array)
        append(element);  
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendAll(Iterable<?> iterable) {
    if (iterable != null)
      for (Object o : iterable)
        append(o);  
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendAll(Iterator<?> it) {
    if (it != null)
      while (it.hasNext())
        append(it.next());  
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendWithSeparators(Object[] array, String separator) {
    if (array != null && array.length > 0) {
      String sep = Objects.toString(separator, "");
      append(array[0]);
      for (int i = 1; i < array.length; i++) {
        append(sep);
        append(array[i]);
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendWithSeparators(Iterable<?> iterable, String separator) {
    if (iterable != null) {
      String sep = Objects.toString(separator, "");
      Iterator<?> it = iterable.iterator();
      while (it.hasNext()) {
        append(it.next());
        if (it.hasNext())
          append(sep); 
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendWithSeparators(Iterator<?> it, String separator) {
    if (it != null) {
      String sep = Objects.toString(separator, "");
      while (it.hasNext()) {
        append(it.next());
        if (it.hasNext())
          append(sep); 
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendSeparator(String separator) {
    return appendSeparator(separator, null);
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendSeparator(String standard, String defaultIfEmpty) {
    String str = isEmpty() ? defaultIfEmpty : standard;
    if (str != null)
      append(str); 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendSeparator(char separator) {
    if (isNotEmpty())
      append(separator); 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendSeparator(char standard, char defaultIfEmpty) {
    if (isNotEmpty()) {
      append(standard);
    } else {
      append(defaultIfEmpty);
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendSeparator(String separator, int loopIndex) {
    if (separator != null && loopIndex > 0)
      append(separator); 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendSeparator(char separator, int loopIndex) {
    if (loopIndex > 0)
      append(separator); 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendPadding(int length, char padChar) {
    if (length >= 0) {
      ensureCapacity(this.size + length);
      for (int i = 0; i < length; i++)
        this.buffer[this.size++] = padChar; 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendFixedWidthPadLeft(Object obj, int width, char padChar) {
    if (width > 0) {
      ensureCapacity(this.size + width);
      String str = (obj == null) ? getNullText() : obj.toString();
      if (str == null)
        str = ""; 
      int strLen = str.length();
      if (strLen >= width) {
        str.getChars(strLen - width, strLen, this.buffer, this.size);
      } else {
        int padLen = width - strLen;
        for (int i = 0; i < padLen; i++)
          this.buffer[this.size + i] = padChar; 
        str.getChars(0, strLen, this.buffer, this.size + padLen);
      } 
      this.size += width;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendFixedWidthPadLeft(int value, int width, char padChar) {
    return appendFixedWidthPadLeft(String.valueOf(value), width, padChar);
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendFixedWidthPadRight(Object obj, int width, char padChar) {
    if (width > 0) {
      ensureCapacity(this.size + width);
      String str = (obj == null) ? getNullText() : obj.toString();
      if (str == null)
        str = ""; 
      int strLen = str.length();
      if (strLen >= width) {
        str.getChars(0, width, this.buffer, this.size);
      } else {
        int padLen = width - strLen;
        str.getChars(0, strLen, this.buffer, this.size);
        for (int i = 0; i < padLen; i++)
          this.buffer[this.size + strLen + i] = padChar; 
      } 
      this.size += width;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder appendFixedWidthPadRight(int value, int width, char padChar) {
    return appendFixedWidthPadRight(String.valueOf(value), width, padChar);
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, Object obj) {
    if (obj == null)
      return insert(index, this.nullText); 
    return insert(index, obj.toString());
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, String str) {
    validateIndex(index);
    if (str == null)
      str = this.nullText; 
    if (str != null) {
      int strLen = str.length();
      if (strLen > 0) {
        int newSize = this.size + strLen;
        ensureCapacity(newSize);
        System.arraycopy(this.buffer, index, this.buffer, index + strLen, this.size - index);
        this.size = newSize;
        str.getChars(0, strLen, this.buffer, index);
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, char[] chars) {
    validateIndex(index);
    if (chars == null)
      return insert(index, this.nullText); 
    int len = chars.length;
    if (len > 0) {
      ensureCapacity(this.size + len);
      System.arraycopy(this.buffer, index, this.buffer, index + len, this.size - index);
      System.arraycopy(chars, 0, this.buffer, index, len);
      this.size += len;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, char[] chars, int offset, int length) {
    validateIndex(index);
    if (chars == null)
      return insert(index, this.nullText); 
    if (offset < 0 || offset > chars.length)
      throw new StringIndexOutOfBoundsException("Invalid offset: " + offset); 
    if (length < 0 || offset + length > chars.length)
      throw new StringIndexOutOfBoundsException("Invalid length: " + length); 
    if (length > 0) {
      ensureCapacity(this.size + length);
      System.arraycopy(this.buffer, index, this.buffer, index + length, this.size - index);
      System.arraycopy(chars, offset, this.buffer, index, length);
      this.size += length;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, boolean value) {
    validateIndex(index);
    if (value) {
      ensureCapacity(this.size + 4);
      System.arraycopy(this.buffer, index, this.buffer, index + 4, this.size - index);
      this.buffer[index++] = 't';
      this.buffer[index++] = 'r';
      this.buffer[index++] = 'u';
      this.buffer[index] = 'e';
      this.size += 4;
    } else {
      ensureCapacity(this.size + 5);
      System.arraycopy(this.buffer, index, this.buffer, index + 5, this.size - index);
      this.buffer[index++] = 'f';
      this.buffer[index++] = 'a';
      this.buffer[index++] = 'l';
      this.buffer[index++] = 's';
      this.buffer[index] = 'e';
      this.size += 5;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, char value) {
    validateIndex(index);
    ensureCapacity(this.size + 1);
    System.arraycopy(this.buffer, index, this.buffer, index + 1, this.size - index);
    this.buffer[index] = value;
    this.size++;
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, int value) {
    return insert(index, String.valueOf(value));
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, long value) {
    return insert(index, String.valueOf(value));
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, float value) {
    return insert(index, String.valueOf(value));
  }
  
  public org.apache.commons.lang3.text.StrBuilder insert(int index, double value) {
    return insert(index, String.valueOf(value));
  }
  
  private void deleteImpl(int startIndex, int endIndex, int len) {
    System.arraycopy(this.buffer, endIndex, this.buffer, startIndex, this.size - endIndex);
    this.size -= len;
  }
  
  public org.apache.commons.lang3.text.StrBuilder delete(int startIndex, int endIndex) {
    endIndex = validateRange(startIndex, endIndex);
    int len = endIndex - startIndex;
    if (len > 0)
      deleteImpl(startIndex, endIndex, len); 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder deleteAll(char ch) {
    for (int i = 0; i < this.size; i++) {
      if (this.buffer[i] == ch) {
        int start = i;
        do {
        
        } while (++i < this.size && 
          this.buffer[i] == ch);
        int len = i - start;
        deleteImpl(start, i, len);
        i -= len;
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder deleteFirst(char ch) {
    for (int i = 0; i < this.size; i++) {
      if (this.buffer[i] == ch) {
        deleteImpl(i, i + 1, 1);
        break;
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder deleteAll(String str) {
    int len = (str == null) ? 0 : str.length();
    if (len > 0) {
      int index = indexOf(str, 0);
      while (index >= 0) {
        deleteImpl(index, index + len, len);
        index = indexOf(str, index);
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder deleteFirst(String str) {
    int len = (str == null) ? 0 : str.length();
    if (len > 0) {
      int index = indexOf(str, 0);
      if (index >= 0)
        deleteImpl(index, index + len, len); 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder deleteAll(StrMatcher matcher) {
    return replace(matcher, null, 0, this.size, -1);
  }
  
  public org.apache.commons.lang3.text.StrBuilder deleteFirst(StrMatcher matcher) {
    return replace(matcher, null, 0, this.size, 1);
  }
  
  private void replaceImpl(int startIndex, int endIndex, int removeLen, String insertStr, int insertLen) {
    int newSize = this.size - removeLen + insertLen;
    if (insertLen != removeLen) {
      ensureCapacity(newSize);
      System.arraycopy(this.buffer, endIndex, this.buffer, startIndex + insertLen, this.size - endIndex);
      this.size = newSize;
    } 
    if (insertLen > 0)
      insertStr.getChars(0, insertLen, this.buffer, startIndex); 
  }
  
  public org.apache.commons.lang3.text.StrBuilder replace(int startIndex, int endIndex, String replaceStr) {
    endIndex = validateRange(startIndex, endIndex);
    int insertLen = (replaceStr == null) ? 0 : replaceStr.length();
    replaceImpl(startIndex, endIndex, endIndex - startIndex, replaceStr, insertLen);
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder replaceAll(char search, char replace) {
    if (search != replace)
      for (int i = 0; i < this.size; i++) {
        if (this.buffer[i] == search)
          this.buffer[i] = replace; 
      }  
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder replaceFirst(char search, char replace) {
    if (search != replace)
      for (int i = 0; i < this.size; i++) {
        if (this.buffer[i] == search) {
          this.buffer[i] = replace;
          break;
        } 
      }  
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder replaceAll(String searchStr, String replaceStr) {
    int searchLen = (searchStr == null) ? 0 : searchStr.length();
    if (searchLen > 0) {
      int replaceLen = (replaceStr == null) ? 0 : replaceStr.length();
      int index = indexOf(searchStr, 0);
      while (index >= 0) {
        replaceImpl(index, index + searchLen, searchLen, replaceStr, replaceLen);
        index = indexOf(searchStr, index + replaceLen);
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder replaceFirst(String searchStr, String replaceStr) {
    int searchLen = (searchStr == null) ? 0 : searchStr.length();
    if (searchLen > 0) {
      int index = indexOf(searchStr, 0);
      if (index >= 0) {
        int replaceLen = (replaceStr == null) ? 0 : replaceStr.length();
        replaceImpl(index, index + searchLen, searchLen, replaceStr, replaceLen);
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder replaceAll(StrMatcher matcher, String replaceStr) {
    return replace(matcher, replaceStr, 0, this.size, -1);
  }
  
  public org.apache.commons.lang3.text.StrBuilder replaceFirst(StrMatcher matcher, String replaceStr) {
    return replace(matcher, replaceStr, 0, this.size, 1);
  }
  
  public org.apache.commons.lang3.text.StrBuilder replace(StrMatcher matcher, String replaceStr, int startIndex, int endIndex, int replaceCount) {
    endIndex = validateRange(startIndex, endIndex);
    return replaceImpl(matcher, replaceStr, startIndex, endIndex, replaceCount);
  }
  
  private org.apache.commons.lang3.text.StrBuilder replaceImpl(StrMatcher matcher, String replaceStr, int from, int to, int replaceCount) {
    if (matcher == null || this.size == 0)
      return this; 
    int replaceLen = (replaceStr == null) ? 0 : replaceStr.length();
    for (int i = from; i < to && replaceCount != 0; i++) {
      char[] buf = this.buffer;
      int removeLen = matcher.isMatch(buf, i, from, to);
      if (removeLen > 0) {
        replaceImpl(i, i + removeLen, removeLen, replaceStr, replaceLen);
        to = to - removeLen + replaceLen;
        i = i + replaceLen - 1;
        if (replaceCount > 0)
          replaceCount--; 
      } 
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder reverse() {
    if (this.size == 0)
      return this; 
    int half = this.size / 2;
    char[] buf = this.buffer;
    for (int leftIdx = 0, rightIdx = this.size - 1; leftIdx < half; leftIdx++, rightIdx--) {
      char swap = buf[leftIdx];
      buf[leftIdx] = buf[rightIdx];
      buf[rightIdx] = swap;
    } 
    return this;
  }
  
  public org.apache.commons.lang3.text.StrBuilder trim() {
    if (this.size == 0)
      return this; 
    int len = this.size;
    char[] buf = this.buffer;
    int pos = 0;
    while (pos < len && buf[pos] <= ' ')
      pos++; 
    while (pos < len && buf[len - 1] <= ' ')
      len--; 
    if (len < this.size)
      delete(len, this.size); 
    if (pos > 0)
      delete(0, pos); 
    return this;
  }
  
  public boolean startsWith(String str) {
    if (str == null)
      return false; 
    int len = str.length();
    if (len == 0)
      return true; 
    if (len > this.size)
      return false; 
    for (int i = 0; i < len; i++) {
      if (this.buffer[i] != str.charAt(i))
        return false; 
    } 
    return true;
  }
  
  public boolean endsWith(String str) {
    if (str == null)
      return false; 
    int len = str.length();
    if (len == 0)
      return true; 
    if (len > this.size)
      return false; 
    int pos = this.size - len;
    for (int i = 0; i < len; i++, pos++) {
      if (this.buffer[pos] != str.charAt(i))
        return false; 
    } 
    return true;
  }
  
  public CharSequence subSequence(int startIndex, int endIndex) {
    if (startIndex < 0)
      throw new StringIndexOutOfBoundsException(startIndex); 
    if (endIndex > this.size)
      throw new StringIndexOutOfBoundsException(endIndex); 
    if (startIndex > endIndex)
      throw new StringIndexOutOfBoundsException(endIndex - startIndex); 
    return substring(startIndex, endIndex);
  }
  
  public String substring(int start) {
    return substring(start, this.size);
  }
  
  public String substring(int startIndex, int endIndex) {
    endIndex = validateRange(startIndex, endIndex);
    return new String(this.buffer, startIndex, endIndex - startIndex);
  }
  
  public String leftString(int length) {
    if (length <= 0)
      return ""; 
    if (length >= this.size)
      return new String(this.buffer, 0, this.size); 
    return new String(this.buffer, 0, length);
  }
  
  public String rightString(int length) {
    if (length <= 0)
      return ""; 
    if (length >= this.size)
      return new String(this.buffer, 0, this.size); 
    return new String(this.buffer, this.size - length, length);
  }
  
  public String midString(int index, int length) {
    if (index < 0)
      index = 0; 
    if (length <= 0 || index >= this.size)
      return ""; 
    if (this.size <= index + length)
      return new String(this.buffer, index, this.size - index); 
    return new String(this.buffer, index, length);
  }
  
  public boolean contains(char ch) {
    char[] thisBuf = this.buffer;
    for (int i = 0; i < this.size; i++) {
      if (thisBuf[i] == ch)
        return true; 
    } 
    return false;
  }
  
  public boolean contains(String str) {
    return (indexOf(str, 0) >= 0);
  }
  
  public boolean contains(StrMatcher matcher) {
    return (indexOf(matcher, 0) >= 0);
  }
  
  public int indexOf(char ch) {
    return indexOf(ch, 0);
  }
  
  public int indexOf(char ch, int startIndex) {
    startIndex = Math.max(startIndex, 0);
    if (startIndex >= this.size)
      return -1; 
    char[] thisBuf = this.buffer;
    for (int i = startIndex; i < this.size; i++) {
      if (thisBuf[i] == ch)
        return i; 
    } 
    return -1;
  }
  
  public int indexOf(String str) {
    return indexOf(str, 0);
  }
  
  public int indexOf(String str, int startIndex) {
    startIndex = Math.max(startIndex, 0);
    if (str == null || startIndex >= this.size)
      return -1; 
    int strLen = str.length();
    if (strLen == 1)
      return indexOf(str.charAt(0), startIndex); 
    if (strLen == 0)
      return startIndex; 
    if (strLen > this.size)
      return -1; 
    char[] thisBuf = this.buffer;
    int len = this.size - strLen + 1;
    for (int i = startIndex; i < len; i++) {
      int j = 0;
      while (true) {
        if (j < strLen) {
          if (str.charAt(j) != thisBuf[i + j])
            break; 
          j++;
          continue;
        } 
        return i;
      } 
    } 
    return -1;
  }
  
  public int indexOf(StrMatcher matcher) {
    return indexOf(matcher, 0);
  }
  
  public int indexOf(StrMatcher matcher, int startIndex) {
    startIndex = Math.max(startIndex, 0);
    if (matcher == null || startIndex >= this.size)
      return -1; 
    int len = this.size;
    char[] buf = this.buffer;
    for (int i = startIndex; i < len; i++) {
      if (matcher.isMatch(buf, i, startIndex, len) > 0)
        return i; 
    } 
    return -1;
  }
  
  public int lastIndexOf(char ch) {
    return lastIndexOf(ch, this.size - 1);
  }
  
  public int lastIndexOf(char ch, int startIndex) {
    startIndex = (startIndex >= this.size) ? (this.size - 1) : startIndex;
    if (startIndex < 0)
      return -1; 
    for (int i = startIndex; i >= 0; i--) {
      if (this.buffer[i] == ch)
        return i; 
    } 
    return -1;
  }
  
  public int lastIndexOf(String str) {
    return lastIndexOf(str, this.size - 1);
  }
  
  public int lastIndexOf(String str, int startIndex) {
    startIndex = (startIndex >= this.size) ? (this.size - 1) : startIndex;
    if (str == null || startIndex < 0)
      return -1; 
    int strLen = str.length();
    if (strLen > 0 && strLen <= this.size) {
      if (strLen == 1)
        return lastIndexOf(str.charAt(0), startIndex); 
      for (int i = startIndex - strLen + 1; i >= 0; i--) {
        int j = 0;
        while (true) {
          if (j < strLen) {
            if (str.charAt(j) != this.buffer[i + j])
              break; 
            j++;
            continue;
          } 
          return i;
        } 
      } 
    } else if (strLen == 0) {
      return startIndex;
    } 
    return -1;
  }
  
  public int lastIndexOf(StrMatcher matcher) {
    return lastIndexOf(matcher, this.size);
  }
  
  public int lastIndexOf(StrMatcher matcher, int startIndex) {
    startIndex = (startIndex >= this.size) ? (this.size - 1) : startIndex;
    if (matcher == null || startIndex < 0)
      return -1; 
    char[] buf = this.buffer;
    int endIndex = startIndex + 1;
    for (int i = startIndex; i >= 0; i--) {
      if (matcher.isMatch(buf, i, 0, endIndex) > 0)
        return i; 
    } 
    return -1;
  }
  
  public StrTokenizer asTokenizer() {
    return (StrTokenizer)new StrBuilderTokenizer(this);
  }
  
  public Reader asReader() {
    return (Reader)new StrBuilderReader(this);
  }
  
  public Writer asWriter() {
    return (Writer)new StrBuilderWriter(this);
  }
  
  public void appendTo(Appendable appendable) throws IOException {
    if (appendable instanceof Writer) {
      ((Writer)appendable).write(this.buffer, 0, this.size);
    } else if (appendable instanceof StringBuilder) {
      ((StringBuilder)appendable).append(this.buffer, 0, this.size);
    } else if (appendable instanceof StringBuffer) {
      ((StringBuffer)appendable).append(this.buffer, 0, this.size);
    } else if (appendable instanceof CharBuffer) {
      ((CharBuffer)appendable).put(this.buffer, 0, this.size);
    } else {
      appendable.append(this);
    } 
  }
  
  public boolean equalsIgnoreCase(org.apache.commons.lang3.text.StrBuilder other) {
    if (this == other)
      return true; 
    if (this.size != other.size)
      return false; 
    char[] thisBuf = this.buffer;
    char[] otherBuf = other.buffer;
    for (int i = this.size - 1; i >= 0; i--) {
      char c1 = thisBuf[i];
      char c2 = otherBuf[i];
      if (c1 != c2 && Character.toUpperCase(c1) != Character.toUpperCase(c2))
        return false; 
    } 
    return true;
  }
  
  public boolean equals(org.apache.commons.lang3.text.StrBuilder other) {
    if (this == other)
      return true; 
    if (other == null)
      return false; 
    if (this.size != other.size)
      return false; 
    char[] thisBuf = this.buffer;
    char[] otherBuf = other.buffer;
    for (int i = this.size - 1; i >= 0; i--) {
      if (thisBuf[i] != otherBuf[i])
        return false; 
    } 
    return true;
  }
  
  public boolean equals(Object obj) {
    return (obj instanceof org.apache.commons.lang3.text.StrBuilder && equals((org.apache.commons.lang3.text.StrBuilder)obj));
  }
  
  public int hashCode() {
    char[] buf = this.buffer;
    int hash = 0;
    for (int i = this.size - 1; i >= 0; i--)
      hash = 31 * hash + buf[i]; 
    return hash;
  }
  
  public String toString() {
    return new String(this.buffer, 0, this.size);
  }
  
  public StringBuffer toStringBuffer() {
    return (new StringBuffer(this.size)).append(this.buffer, 0, this.size);
  }
  
  public StringBuilder toStringBuilder() {
    return (new StringBuilder(this.size)).append(this.buffer, 0, this.size);
  }
  
  public String build() {
    return toString();
  }
  
  protected int validateRange(int startIndex, int endIndex) {
    if (startIndex < 0)
      throw new StringIndexOutOfBoundsException(startIndex); 
    if (endIndex > this.size)
      endIndex = this.size; 
    if (startIndex > endIndex)
      throw new StringIndexOutOfBoundsException("end < start"); 
    return endIndex;
  }
  
  protected void validateIndex(int index) {
    if (index < 0 || index > this.size)
      throw new StringIndexOutOfBoundsException(index); 
  }
}
